#pragma once
#include "UIElement.h"
#include <vector>

class UIChatElement : public UIElement
{
public:
	//void DrawRetryStatus(Graphics* graph, CRect rcPS);
	UIChatElement(CChatItem* pChatItem, IUIElementResouce* pResouce);

	virtual ~UIChatElement(void);

	virtual BOOL Draw(Graphics *graph );
	virtual CSize CalcSize(const CPoint& ptPos, DWORD dwFlags);
	virtual void OnLButtonDown(UINT nFlags, CPoint point);
	virtual void OnLButtonDblClk( UINT nFlags, CPoint point );
	virtual BOOL OnMouseMove( UINT nFlags, CPoint point );
	virtual void OnLButtonUp( UINT nFlags, CPoint point );
protected:
	void  _DrawName(CString strName, Graphics* graph, CRect rtPS);
	//void  _DrawTime(CString strTime, Graphics* graph, CRect rtPS);
	void  _DrawUserMessage(Graphics* graph, CRect rcPS);
	void  _DrawReSendStatus(Graphics* graph, CRect rcPS);
	CSize _CalcPlainSize(const CPoint& ptPos, DWORD dwFlags );
	CSize _CalcBubbleSize(const CPoint& ptPos, DWORD dwFlags );
	CSize _CalcBubbleSendStatus(const CPoint& ptPos, DWORD dwFlags);
	CRect _CalcPlainUserName();
	CRect _CalcPlainTime();
	CSize _CalcReSendStatus(const CPoint& ptPos, CSize& sz);

	void _DrawBubbleChat(Graphics* graph);
	void _DrawBubble(Graphics* graph, CRect rcBubble, BOOL bMine);
	Image* _GetBubbleImage(BOOL bMine, int nIndex);


	CSize _CalcUserMessage(CPoint& ptPos);
	void  _Clear();
	void  _CutMsgStringForLines(CString strMsg, vector<CString>& vecMsgLines);
	CRect _ClientToContianer(CPoint& ptPos, CRect& rcClient);

	void  _SetChatSelectedItem(CPoint ptStart, CPoint ptEnd, BOOL bSelectWord);
	int   _GetStringIndexUnderPoint(CPoint point, int nDisplayType);

	void  _SetPlainChatSelectedItem(CPoint ptStart, CPoint ptEnd, BOOL bSelectWord);
	BOOL  _IsPointInPlainSelectionRects(const CPoint& ptPos);
	BOOL  _GetStringPosFormPoint( CPoint& ptPos, int& nLine, int& nIndexOfLine);
	int   _GetStringPosFormPoint(const CPoint& ptPos);
	BOOL  _IsPointInPlainUserMassageLeftCorner(const CPoint& ptPos);
	BOOL  _IsDefaultFontAndSize();

	Color _GetMsgColor();
	
	CRect m_rtUserMessage;
	

	CRect m_rcSendCount;


	CSize m_szUserMessage;

	int		m_nSingleRowWith;


};